'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var palette = require('@guardian/src-foundations/palette/cjs');

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

var accordionDefault = {
  accordion: {
    textPrimary: palette.text.primary,
    borderPrimary: palette.border.primary
  }
};

var buttonDefault = {
  button: {
    textPrimary: palette.text.ctaPrimary,
    backgroundPrimary: palette.background.ctaPrimary,
    backgroundPrimaryHover: palette.background.ctaPrimaryHover,
    textSecondary: palette.text.ctaSecondary,
    backgroundSecondary: palette.background.ctaSecondary,
    backgroundSecondaryHover: palette.background.ctaSecondaryHover,
    textTertiary: palette.text.ctaTertiary,
    backgroundTertiaryHover: palette.background.ctaTertiaryHover,
    borderTertiary: palette.border.ctaTertiary,
    textSubdued: palette.text.ctaSecondary
  }
};
var buttonBrand = {
  button: {
    textPrimary: palette.brandText.ctaPrimary,
    backgroundPrimary: palette.brandBackground.ctaPrimary,
    backgroundPrimaryHover: palette.brandBackground.ctaPrimaryHover,
    textSecondary: palette.brandText.ctaSecondary,
    backgroundSecondary: palette.brandBackground.ctaSecondary,
    backgroundSecondaryHover: palette.brandBackground.ctaSecondaryHover,
    textTertiary: palette.brandText.ctaTertiary,
    backgroundTertiaryHover: palette.brandBackground.ctaTertiaryHover,
    borderTertiary: palette.brandBorder.ctaTertiary,
    textSubdued: palette.brandText.ctaSecondary
  }
};
var buttonBrandAlt = {
  button: {
    textPrimary: palette.brandAltText.ctaPrimary,
    backgroundPrimary: palette.brandAltBackground.ctaPrimary,
    backgroundPrimaryHover: palette.brandAltBackground.ctaPrimaryHover,
    textSecondary: palette.brandAltText.ctaSecondary,
    backgroundSecondary: palette.brandAltBackground.ctaSecondary,
    backgroundSecondaryHover: palette.brandAltBackground.ctaSecondaryHover,
    textTertiary: palette.brandAltText.ctaTertiary,
    backgroundTertiaryHover: palette.brandAltBackground.ctaTertiaryHover,
    borderTertiary: palette.brandAltBorder.ctaTertiary,
    textSubdued: palette.brandAltText.ctaSecondary
  }
}; // continue to expose legacy theme names

var buttonLight = buttonDefault;
var buttonBrandYellow = buttonBrandAlt;

var inlineErrorDefault = {
  inlineError: {
    text: palette.text.error
  }
};
var inlineErrorBrand = {
  inlineError: {
    text: palette.brandText.error
  }
}; // continue to expose legacy theme names

var inlineErrorLight = inlineErrorDefault;

var checkboxDefault = _objectSpread2({
  checkbox: {
    border: palette.border.input,
    borderHover: palette.border.inputHover,
    borderChecked: palette.border.inputChecked,
    borderError: palette.border.error,
    backgroundChecked: palette.background.inputChecked,
    textLabel: palette.text.inputLabel,
    textLabelSupporting: palette.text.inputLabelSupporting,
    textIndeterminate: palette.text.supporting
  }
}, inlineErrorDefault);
var checkboxBrand = _objectSpread2({
  checkbox: {
    border: palette.brandBorder.input,
    borderHover: palette.brandBorder.inputHover,
    borderChecked: palette.brandBorder.inputChecked,
    borderError: palette.brandBorder.error,
    backgroundChecked: palette.brandBackground.inputChecked,
    textLabel: palette.brandText.inputLabel,
    textLabelSupporting: palette.brandText.inputLabelSupporting,
    textIndeterminate: palette.brandText.supporting
  }
}, inlineErrorBrand); // continue to expose legacy theme names

var checkboxLight = checkboxDefault;

var choiceCardDefault = _objectSpread2({
  choiceCard: {
    textLabel: palette.text.supporting,
    textLabelSupporting: palette.text.supporting,
    textGroupLabel: palette.text.groupLabel,
    textGroupLabelSupporting: palette.text.groupLabelSupporting,
    border: palette.border.input,
    textChecked: palette.text.inputChecked,
    backgroundChecked: "#E3F6FF",
    backgroundTick: palette.background.inputChecked,
    borderChecked: palette.border.inputChecked,
    textHover: palette.text.inputHover,
    borderHover: palette.border.inputHover,
    textError: palette.text.error,
    borderError: palette.border.error
  }
}, inlineErrorDefault);

var linkDefault = {
  link: {
    textPrimary: palette.text.anchorPrimary,
    textPrimaryHover: palette.text.anchorPrimary,
    textSecondary: palette.text.anchorSecondary,
    textSecondaryHover: palette.text.anchorSecondary
  }
};
var linkBrand = {
  link: {
    textPrimary: palette.brandText.anchorPrimary,
    textPrimaryHover: palette.brandText.anchorPrimary
  }
};
var linkBrandAlt = {
  link: {
    textPrimary: palette.brandAltText.anchorPrimary,
    textPrimaryHover: palette.brandAltText.anchorPrimary
  }
}; // continue to expose legacy theme names

var linkLight = linkDefault;
var linkBrandYellow = linkBrandAlt;

var radioDefault = _objectSpread2({
  radio: {
    borderHover: palette.border.inputHover,
    border: palette.border.input,
    backgroundChecked: palette.background.inputChecked,
    textLabel: palette.text.inputLabel,
    textLabelSupporting: palette.text.inputLabelSupporting,
    borderError: palette.border.error
  }
}, inlineErrorLight);
var radioBrand = _objectSpread2({
  radio: {
    borderHover: palette.brandBorder.inputHover,
    border: palette.brandBorder.input,
    backgroundChecked: palette.brandBackground.inputChecked,
    textLabel: palette.brandText.inputLabel,
    textLabelSupporting: palette.brandText.supporting,
    borderError: palette.brandBorder.error
  }
}, inlineErrorBrand); // continue to expose legacy theme names

var radioLight = radioDefault;

var textInputDefault = _objectSpread2({
  textInput: {
    textUserInput: palette.text.userInput,
    textLabel: palette.text.inputLabel,
    textLabelOptional: palette.text.supporting,
    textLabelSupporting: palette.text.supporting,
    textError: palette.text.error,
    backgroundInput: palette.background.input,
    border: palette.border.input,
    borderActive: palette.border.inputActive,
    borderError: palette.border.error
  }
}, inlineErrorDefault); // continue to expose legacy theme names

var textInputLight = textInputDefault;

var defaultTheme = _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, buttonDefault), checkboxDefault), choiceCardDefault), inlineErrorDefault), linkDefault), radioDefault), textInputDefault), buttonLight), checkboxLight), inlineErrorLight), linkLight), radioLight), textInputLight);
var brand = _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, buttonBrand), checkboxBrand), inlineErrorBrand), linkBrand), radioBrand);
var brandAlt = _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, buttonBrandAlt), linkBrandAlt), buttonBrandYellow), linkBrandYellow); // continue to expose legacy theme names

var light = defaultTheme;
var brandYellow = brandAlt;

exports.accordionDefault = accordionDefault;
exports.brand = brand;
exports.brandAlt = brandAlt;
exports.brandYellow = brandYellow;
exports.buttonBrand = buttonBrand;
exports.buttonBrandAlt = buttonBrandAlt;
exports.buttonBrandYellow = buttonBrandYellow;
exports.buttonDefault = buttonDefault;
exports.buttonLight = buttonLight;
exports.checkboxBrand = checkboxBrand;
exports.checkboxDefault = checkboxDefault;
exports.checkboxLight = checkboxLight;
exports.choiceCardDefault = choiceCardDefault;
exports.defaultTheme = defaultTheme;
exports.inlineErrorBrand = inlineErrorBrand;
exports.inlineErrorDefault = inlineErrorDefault;
exports.inlineErrorLight = inlineErrorLight;
exports.light = light;
exports.linkBrand = linkBrand;
exports.linkBrandAlt = linkBrandAlt;
exports.linkBrandYellow = linkBrandYellow;
exports.linkDefault = linkDefault;
exports.linkLight = linkLight;
exports.radioBrand = radioBrand;
exports.radioDefault = radioDefault;
exports.radioLight = radioLight;
exports.textInputDefault = textInputDefault;
exports.textInputLight = textInputLight;
